 package org.sky.system.wrapper;

 import org.sky.core.mp.support.BaseEntityWrapper;
 import org.sky.core.tool.node.ForestNodeMerger;
 import org.sky.core.tool.utils.BeanUtil;
 import org.sky.system.cache.RegionCache;
 import org.sky.system.pojo.entity.Region;
 import org.sky.system.pojo.vo.RegionVO;

 import java.util.List;
 import java.util.Objects;

/**
 * 包装类,返回视图层所需的字段
 *
  */
public class RegionWrapper extends BaseEntityWrapper<Region, RegionVO> {

	public static RegionWrapper build() {
		return new RegionWrapper();
	}

	@Override
	public RegionVO entityVO(Region region) {
		RegionVO regionVO = Objects.requireNonNull(BeanUtil.copyProperties(region, RegionVO.class));
		Region parentRegion = RegionCache.getByCode(region.getParentCode());
		regionVO.setParentName(parentRegion.getName());
		return regionVO;
	}

	public List<RegionVO> listNodeLazyVO(List<RegionVO> list) {
		return ForestNodeMerger.merge(list);
	}

}
